	.text
	.code32

/*
 * This has got to be one of the most cursed routines within stage1.
 * Temporarily returns to Real Mode, does a BIOS interrupt, and then
 * goes back to Protected Mode again.  Furthermore, the interrupt
 * number is written ahead of time by the callee.
 */
/* fn __do_bios_int(regs: &mut BiosIntRegs) -> u8 */
GLOBL __do_bios_int
	pushal						// '1 (4 -> 36)

	/*
	 * Move the `regs` parameter into %ebp.  `call` pushes one longword
	 * (4 bytes) for the return address, then the `pushal` above pushes
	 * 8 longwords (32 bytes), so the pointer is at offset 36.
	 */
	mov	36(%esp), %ebp
	/* now load all registers with their desired values */
	mov	24(%ebp), %eax
	push	%eax		/* %ds and %es */	//  '2 (36 -> 40)
	mov	(%ebp), %eax
	mov	4(%ebp), %ecx
	mov	8(%ebp), %edx
	mov	12(%ebp), %ebx
	mov	16(%ebp), %esi
	mov	20(%ebp), %edi

	push	%eax					//   '3 (40 -> 44)
	push	%edx					//    '4 (44 -> 48)
	call	prot_to_real
	.code16
	pop	%edx					//    '4 (44 <- 48)
	pop	%eax					//   '3 (40 <- 44)

	pop	%ds					//  '2 (38 <- 40)
	pop	%es					//  '2 (36 <- 38)

	/* call that polymorphism! */
	.byte 0xcd	/* opcode for `int imm8` */
GLOBL __bios_int_number, object
	.byte 0x18	/* this is the imm8 (overwritten by caller) */

	/* be careful not to touch EFLAGS now because that's our return value */

	push	%es					//  '2 (36 -> 38)
	push	%ds					//  '2 (38 -> 40)

	push	%eax					//   '3 (40 -> 44)
	push	%edx					//    '4 (44 -> 48)
	pushfl						//     '5 (48 -> 52)
	call	real_to_prot
	.code32
	popfl						//     '5 (48 <- 52)
	pop	%edx					//    '4 (44 <- 48)
	pop	%eax					//   '3 (40 <- 44)

	/* the BIOS call might have trashed %ebp, restore it */
	mov	40(%esp), %ebp

	mov	%eax, (%ebp)
	pop	%eax					//  '2 (36 <- 40)
	mov	%eax, 24(%ebp)
	mov	%ecx, 4(%ebp)
	mov	%edx, 8(%ebp)
	mov	%ebx, 12(%ebp)
	mov	%esi, 16(%ebp)
	mov	%edi, 20(%ebp)

	popal						// '1 (4 <- 36)
	setc	%al
	/* this is not really required, but just in case */
	movzbl	%al, %eax

	ret						//'0 (0 <- 4)
END __do_bios_int
