OUTPUT_FORMAT(elf32-i386)
ENTRY(_start)

SEGMENT_SIZE = 0x10000;

SECTIONS {
	. = 0x0500;

	_stage1_start = .;

	.header : {
		KEEP(*(.header))
	}

	.text : ALIGN(8) {
		*(.text .text.*)
	}

	.data : ALIGN(8) {
		*(.data .data.*)
	}

	.rodata : ALIGN(8) {
		*(.rodata .rodata.*)
	}

	_stage1_end = .;

	.bss(NOLOAD) : ALIGN(8) {
		_bss_start = .;
		*(.bss .bss.*)
		_bss_end = .;
	}

	.iomem(NOLOAD) : ALIGN(SEGMENT_SIZE) {
		_disk_buf = .;
		. += SEGMENT_SIZE;
		_disk_buf_end = .;
		_mem_map = .;
		. += SEGMENT_SIZE;
		_mem_map_end = .;
	}
}
